Subject: Re: Wiki setup issues: IRI

From: Martin Duerst <[email-masked]>
Date: Mon, 13 Dec 2004 15:53:51 +0900

Hello Sam,

At the end of this email, you say that you would pick some
quiet time to change the wiki to work with UTF-8/IRIs.
Did you have time to do this? If not, would you mind doing
this soon? It would be really great if our wiki conformed
to what we agree is best practice. If you need help, please
tell me.

Regards,     Martin.

At 02:12 04/07/10, Sam Ruby wrote:
 >Martin Duerst wrote:
 >> When working on http://intertwingly.net/wiki/pie/PaceIRI
 >> (not at all complete yet), I put my name (the real one, with umlaut,
 >> not the one I have to use in my outdated Japanese mailer) in square
 >> brackets at the start of the Abstract like I had seen it on other Paces
 >> such as http://intertwingly.net/wiki/pie/PaceUriOrItsSuccessor.
 >> When I then clicked on it, I got to
 >> http://intertwingly.net/wiki/pie/MartinD_fcrst, which shows
 >> that with a few, probably very simple, changes to the wiki
 >> setup/code, this could be made compatible with IRIs.
 >> Two changes are necessary:
 >> 1) Change the wiki to use UTF-8 for its page encoding rather than
 >>    iso-8859-1. For a new wiki, this should just be a setup issue
 >>    (otherwise, choose another wiki software, or maybe another ISP).
 >>    For the current wiki, pages with non-ASCII characters have to be
 >>    converted to UTF-8 at the same time the setup is changed.
 >>    Doing that is easy if you have access to the actual files.
 >>    In line with http://intertwingly.net/stories/2004/04/14/i18n.html,
 >>    I would suggest that we do that anyway, and I'm ready to help.
 >>    This would then change the above URI from
 >>    http://intertwingly.net/wiki/pie/MartinD_fcrst to
 >>    http://intertwingly.net/wiki/pie/MartinD_c3_bcrst.
 >
 >In moin_config.py, there is the following:
 >
 >   charset = 'iso-8859-1'
 >
 >While this looks hopeful, it seems to me that such a change would not 
only affect the character set used within the pages, but would also change 
the NAME of the page.  Simply put, MartinD_fcrst and MartinD_c3_bcrst are 
separate pages, and changing the encoding used in the page would change 
which one of these pages were the target of the link.
 >
 >Examples of pages it would affect:
 >
 >http://www.intertwingly.net/wiki/pie/Fran_e7oisGranger?action=fullsearch&value=Fran%E7oisGranger&literal=1&case=1&context=40
 >
 >Thinking about it a bit, my preference is to NOT directly fix the source 
files.  It seems to me that the number of issues should be small - I am 
quite willing to write programs to generate reports of potentially 
problematic pages, but unless the changes required are massive AND readily 
and safely automatable, then I would prefer that the change be made by hand.
 >
 >> 2) Change the escape character from '_' to '%'. This would change
 >>    the above URI from
 >>    http://intertwingly.net/wiki/pie/MartinD_c3_bcrst to
 >>    http://intertwingly.net/wiki/pie/MartinD%c3%bcrst.
 >>    While at it, please also change escaping from lowercase to
 >>    upper case, in accordance with 2396bis. This would give
 >>    http://intertwingly.net/wiki/pie/MartinD%C3%BCrst.
 >
 >This also changes the name of the page.  In particular, some of the help 
pages delivered with Moin have URI escaped slash characters in their name 
(example: http://www.intertwingly.net/wiki/pie/HelpOnInstalling).
 >
 >However, it looks like the code change itself should be simple as the 
mapping is done in exactly one place.
 >
 >> The two changes are largely independent, and can be done in any order.
 >> If everything goes well, the file names are then actually readable,
 >> on an Unix/Linux system assuming you have selected an UTF-8 locale (most
 >> new Linux systems are shipped that way, as far as I understand).
 >
 >It looks to me that the way to proceed is to pick some relatively quiet 
time (perhaps this weekend), make both changes at once, and then fix what breaks.
 >
 >> As I said, I'd be very glad to help get this fixed.
 >> I don't really care too much about my own name, I could
 >> use 'Duerst' as a fallback, but it'd really be better
 >> to fix this on this occasion.
 >> Regards,    Martin.
 >
 >- Sam Ruby
 >